/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "arp.h"
#include "ethernet.h"


//############################################################################
//Diese Routine berprft ob ein ARP Packet Empfangen wurde
char IfArp (char *packet)
//############################################################################
{
	//2 Byte Hardware Typ: Enthlt den Code fr Ethernet
	if(packet[ARP_HWTYPE+1] == 0x01 &&

	//2 Byte Protokoll Typ: Enthlt den Code fr IP
	packet[ARP_PRTYPE] == 0x08 && packet[ARP_PRTYPE+1] == 0x00 &&

	//1Byte Lnge der Hardwareadresse:Enthlt 6 fr 6 Byte MAC Addresse
	packet[ARP_HWLEN] == 0x06 && 

	//1Byte Lnge der Protokolladresse:Enthlt 4 fr 4 Byte Adressen 
	packet[ARP_PRLEN] == 0x04 &&

	//Operation handelt es sich um eine anfrage
	packet[ARP_OP+1] == 0x01 &&

	//Ist das ARP Packet fr meine IP Addresse bestimmt
	//Vergleiche ARP Target IP Adresse mit meiner IP
	MYIP[0] == packet[ARP_TIPADDR] &&
	MYIP[1] == packet[ARP_TIPADDR+1] &&
	MYIP[2] == packet[ARP_TIPADDR+2] &&
	MYIP[3] == packet[ARP_TIPADDR+3] )
	{
	return (1);
	}
return (0);
}

//############################################################################
//Diese Routine erzeugt ein ARP buffer
void ARP_Reply (char *buffer,int *bufferlen)
//############################################################################
{
	//Das Erzeugte buffer ist 60 Byte Lang
	*bufferlen = 0x0040;


	//MAC Destadresse wird geschrieben mit MAC Sourceadresse
	//das buffer soll ja zurckgeschickt werden :-)
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a = 0; a < 6; a++)
		{
		buffer[ENETPACKETDEST0+a] = buffer[ENETPACKETSRC0+a];
		}

	//Meine MAC Adresse wird in Sourceadresse geschrieben
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a=0; a<6; a++)
		{
		buffer[ENETPACKETSRC0+a] = mymac[a];
		}

	//ARP operation wird auf 2 gesetzt damit der andere merkt es ist ein ECHO	
	buffer[ARP_OP+1] = 0x02;
	
	//das gleiche fr die MAC Adresse
	//ARP MAC Targetadresse wird geschrieben mit ARP Sourceadresse
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a=0; a<6; a++)
		{
		buffer[ARP_THADDR+a] = buffer[ENETPACKETDEST0+a];
		}

	//ARP Target IP Adresse wird geschrieben mit ARP Source IP Adresse 
	//das mache ich in einer schleife fr alle 4 Byte
	for(int a=0; a<4; a++)
		{
		buffer[ARP_TIPADDR+a] = buffer[ARP_SIPADDR+a];
		}
		
	//ARP MAC Sourceadresse wird geschrieben mit My MAC Adresse
	//das mache ich in einer schleife fr alle 6 Byte
	for(int a=0; a<6; a++)
		{
		buffer[ARP_SHADDR+a] = mymac[a];
		}

	//Meine IP Adresse wird in ARP Source IP Adresse geschrieben
	//das mache ich in einer schleife fr alle 4 Byte
	for(int a=0; a<4; a++)
		{
		buffer[ARP_SIPADDR+a] = MYIP[a];
		}

	//Die restlichen Bytes werden mit 20 beschrieben damit ich die 
	//minimale lnge erhalte
	for(int a=4; a<0x16; a++)
		{
		buffer[ARP_TIPADDR+a] =0x20;
		}

	//Nun ist das ARP buffer fertig zum Senden !!!
	
	//Sendet das erzeugte ARP Packet 
	Write_Ethernet_Frame (buffer,*bufferlen);
}
