/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "ip.h"


//############################################################################
//Diese Routine erzeugt ein IP Packet
void ip (char *buffer)
//############################################################################
{
	//Variablen zur Berechnung der Checksumme
	unsigned int result16;
	
	//IP Destadresse wird geschrieben mit IP Sourceadresse 
	//das packet soll ja zurckgeschickt werden :-)
	//das mache ich in einer schleife fr alle 4 Byte
	for (int a = 0; a < 4; a++)
		{
		buffer[IP_DESTADDR+a] = buffer[IP_SRCADDR+a];
		}
    	
	//Meine IP Adresse wird in Sourceadresse geschrieben
	//das mache ich in einer schleife fr alle 4 Byte
	for (int a = 0; a < 4; a++)
		{
		buffer[IP_SRCADDR+a] = MYIP[a];
		}
    	
	//das gleiche fr die MAC Adresse
	//MAC Destadresse wird geschrieben mit MAC Sourceadresse
	//das mache ich in einer schleife fr alle 6 Byte
	for (int a = 0; a < 6; a++)
		{
		buffer[ENETPACKETDEST0+a] = buffer[ENETPACKETSRC0+a];
		}
	
	//Meine MAC Adresse wird in Sourceadresse geschrieben
	//das mache ich in einer schleife fr alle 6 Byte
	for (int a = 0; a < 6; a++)
		{
		buffer[ENETPACKETSRC0+a] = mymac[a];
		}
	
	//Berechnung der IP Checksumme
	//Alle Daten im IP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	buffer[IP_HDR_CKSUM] = 0x00;
	buffer[IP_HDR_CKSUM+1] = 0x00;
	
	//Berechnung der IP Header lnge	
	result16 = (buffer[IP_VERS_LEN] & 0x0F) << 2;

	//jetzt wird die Checksumme berechnet
	result16 = checksum (&buffer[IP_VERS_LEN], result16, 0);

	//schreibt checksum ins packet (INT H Byte)
	buffer[IP_HDR_CKSUM] = ((result16 & 0xFF00) >> 8);

	//schreibt checksum ins packet (INT L Byte)
	buffer[IP_HDR_CKSUM+1] = (result16 & 0x00FF);

	//Habe Fertig!!
}
