/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _MAIN_H
 #define _MAIN_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#include "rtl8019.h"
#include "tcp.h"
#include "arp.h"
#include "ip.h"
#include "icmp.h"
#include "clock.h"
#include "uart.h"
#include "ftpd.h"
#include "webpage.h"

// BEGIN DS18X20 CODE
#include <avr/eeprom.h>
#include <string.h>

#include "ds18x20/onewire.h"
#include "ds18x20/ds18x20.h"

#include "ds18x20/delay.h"

#define BAUD 9600

#define MAXSENSORS 5
// #define BAUD 9600

extern int checksum (unsigned char * ,unsigned int,unsigned long);
extern void telnet (char* buffer,int *bufferlen);
extern void httpd (char* buffer,int *bufferlen);

extern const unsigned char mymac[];
extern const unsigned char MYIP[];

//MTU Size setzen (min. 500 / max. 1400)
#define MTU_SIZE  1400

//Der Quarz auf dem Experimentierboard hat eine Frequenz von 14.318MHz
#define SYSCLK	8000000 //Quarz Frequenz in Hz
//#define SYSCLK	16000000	//Quarz Frequenz in Hz
uint8_t temperature;
uint8_t Subzero;
#endif //_MAIN_H






